package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.QuickLinks;
import com.izouma.awesomeadmin.service.QuickLinksService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/quickLinks")
@RequiresAuthentication
public class QuickLinksController {

    @Autowired
    private QuickLinksService quickLinksService;

    /**
    * <p>获取全部记录。</p>
    */
//    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(QuickLinks record) {
        List<QuickLinks> pp = quickLinksService.getQuickLinksList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getQuickLinks", method = RequestMethod.GET)
    @ResponseBody
    public Result getQuickLinks(@RequestParam(required = false, value = "id") String id) {
        QuickLinks data = quickLinksService.getQuickLinksById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(QuickLinks record) {
        QuickLinks data = quickLinksService.getQuickLinks(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, QuickLinks record) {
        Map<String, Object> result = new HashMap<>();

        List<QuickLinks> pp =quickLinksService.getQuickLinksByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(QuickLinks record) {
        boolean num = quickLinksService.createQuickLinks(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateQuickLinks(QuickLinks record) {
        boolean num = quickLinksService.updateQuickLinks(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteQuickLinks(@RequestParam(required = true, value = "id") String id) {

        boolean num = quickLinksService.deleteQuickLinks(id);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, QuickLinks record) throws Exception {

    List<QuickLinks> quickLinkss = quickLinksService.getQuickLinksList(record);


        String sheetName = "quick_links";
        String titleName = "快速链接数据表";
        String fileName = "快速链接表";
        int columnNumber = 11;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "类型" ,   "链接名" ,   "地址" ,   "备注" ,   "排序"  };
        String[][] dataList = new String[quickLinkss.size()][11];

        for (int i = 0; i < quickLinkss.size(); i++) {

                        dataList[i][0] = String.valueOf(quickLinkss.get(i).getId());
                        dataList[i][1] = String.valueOf(quickLinkss.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(quickLinkss.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(quickLinkss.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(quickLinkss.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(quickLinkss.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(quickLinkss.get(i).getTypeFlag());
                        dataList[i][7] = String.valueOf(quickLinkss.get(i).getLinkName());
                        dataList[i][8] = String.valueOf(quickLinkss.get(i).getUrl());
                        dataList[i][9] = String.valueOf(quickLinkss.get(i).getRemark());
                        dataList[i][10] = String.valueOf(quickLinkss.get(i).getRank());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

